/* 
 * File:   charge_Fictive_main.c
 * Author: Électro-Bidouilleur
 *
 * Created on August 18, 2015, 12:14 PM
 */

#define _XTAL_FREQ 1000000 //The speed of your internal(or)external oscillator
#define USE_OR_MASKS   // Permet d'utiliser les masques OR prédéfinis dans les fichiers header,
#include <xc.h>        // de la façon  MASK1 | MASK2 | MASK3...
#include <stdio.h>
#include <stdlib.h>
#include <pwm.h>
#include <timers.h>
#include <adc.h>

// CONFIGURATION BYTES
// #pragma config statements should precede project file includes.
// Use project enums instead of #define for ON and OFF.

// CONFIG1H
#pragma config OSC = INTIO2     // Oscillator Selection bits (Internal RC oscillator, port function on RA6 and port function on RA7)
#pragma config FSCM = OFF       // Fail-Safe Clock Monitor Enable bit (Fail-Safe Clock Monitor disabled)
#pragma config IESO = OFF       // Internal External Switchover bit (Internal External Switchover mode disabled)
// CONFIG2L
#pragma config PWRT = OFF       // Power-up Timer Enable bit (PWRT disabled)
#pragma config BOR = OFF        // Brown-out Reset Enable bit (Brown-out Reset disabled)
// BORV = No Setting
// CONFIG2H
#pragma config WDT = OFF        // Watchdog Timer Enable bit (WDT disabled (control is placed on the SWDTEN bit))
#pragma config WDTPS = 32768    // Watchdog Timer Postscale Select bits (1:32768)
// CONFIG3H
#pragma config MCLRE = OFF      // MCLR Pin Enable bit (RA5 input pin enabled, MCLR disabled)
// CONFIG4L
#pragma config STVR = ON        // Stack Full/Underflow Reset Enable bit (Stack full/underflow will cause Reset)
#pragma config LVP = ON         // Low-Voltage ICSP Enable bit (Low-Voltage ICSP enabled)
// CONFIG5L
#pragma config CP0 = OFF        // Code Protection bit (Block 0 (00200-0007FFh) not code-protected)
#pragma config CP1 = OFF        // Code Protection bit (Block 1 (000800-000FFFh) not code-protected)
// CONFIG5H
#pragma config CPB = OFF        // Boot Block Code Protection bit (Boot Block (000000-0001FFh) not code-protected)
#pragma config CPD = OFF        // Data EEPROM Code Protection bit (Data EEPROM not code-protected)
// CONFIG6L
#pragma config WRT0 = OFF       // Write Protection bit (Block 0 (00200-0007FFh) not write-protected)
#pragma config WRT1 = OFF       // Write Protection bit (Block 1 (000800-000FFFh) not write-protected)
// CONFIG6H
#pragma config WRTC = OFF       // Configuration Register Write Protection bit (Configuration registers (300000-3000FFh) not write-protected)
#pragma config WRTB = OFF       // Boot Block Write Protection bit (Boot Block (000000-0001FFh) not write-protected)
#pragma config WRTD = OFF       // Data EEPROM Write Protection bit (Data EEPROM not write-protected)
// CONFIG7L
#pragma config EBTR0 = OFF      // Table Read Protection bit (Block 0 (00200-0007FFh) not protected from table reads executed in other blocks)
#pragma config EBTR1 = OFF      // Table Read Protection bit (Block 1 (000800-000FFFh) not protected from table reads executed in other blocks)
// CONFIG7H
#pragma config EBTRB = OFF      // Boot Block Table Read Protection bit (Boot Block (000000-0001FFh) not protected from table reads executed in other blocks)


void main()
{
    // Configurer l'oscillateur interne à 1MHz
    OSCCON = 0b01000010;

    // Création de variables
    unsigned int cycle_service=0;
    unsigned int ADCResult=0;

    //----Initialiser l'ADC----
    #define adc_config1 (ADC_FOSC_2|ADC_RIGHT_JUST|ADC_2_TAD)
    #define adc_config2 (ADC_CH0|ADC_INT_OFF|ADC_REF_VDD_VSS)
    #define adc_portconfig ADC_2ANA
    OpenADC(adc_config1,adc_config2,adc_portconfig);

//----Configurer le PWM ----
    #define config_timer2 (TIMER_INT_OFF|T2_PS_1_1)
    OpenTimer2(config_timer2);
    #define periode_pwm  0xFF
    OpenPWM1(periode_pwm);            //Configure PWM module and initialize PWM period
    SetDCPWM1(cycle_service);         // Mettre le cycle de service à 0% pour le départ

//----configurer la sortie du PWM----
    #define config_sortie SINGLE_OUT    // sortie unique
    #define mode_sortie PWM_MODE_1   // sortie active en niveau haut
    SetOutputPWM1(config_sortie, mode_sortie);    

//-----Boucle Principale-----
    while(1)    // Boucle Principale
    {
    //---Procéder à un cycle d'échantillonnage de l'ADC
        ConvertADC();
        while(BusyADC());   // Attendre que l'ADC ait terminé la conversion
        ADCResult = ReadADC();
        cycle_service =  ADCResult;
        SetDCPWM1(cycle_service);        //assigner la valeur lue de l'ADC au cycle de service du PWM.
    }

}
